API reference

Custom Tools

5 endpoints. Add your API key in the authentication panel to send test requests from this page.

List custom tools

GET/api/external/v1/tools

Returns a list of all custom tool definitions created by the user, as well as any accessible system tools.

Responses

  • 200List of tools
  • 401Missing or invalid API key
  • 403Key is valid but lacks access to this resource
  • 404Requested resource not found

Create custom tool

POST/api/external/v1/tools

Creates a new custom tool definition. The created tool can be attached to flows to enable external API integrations, custom functions, or call forwarding.

Parameters

  • X-Kilevel-Ai-Originstringheader

Request body application/json

  • idstring (uuid)
  • namestring
  • descriptionstring
  • groupNamestring
  • iconKeystring
  • iconColorstring
  • parametersarray of ToolParameter
  • returnValueToolReturnValue
  • toolTypestring
  • toolSubtypestring
  • isAsyncboolean
  • internalOnlyboolean
  • asyncReturnTypestring
  • messagesToolMessages
  • executionPlanarray of object
  • integrationsarray of object
  • integrationCredentialLinksarray of object
  • forwardCallConfigForwardCallConfig
  • aimetaHintToolMetaHint
  • apiMethodstring
  • apiUrlstring
  • apiTimeoutSecondsinteger (int32)
  • toolCallTimeoutSecondsinteger (int32)
  • requiresConfirmedTranscriptboolean
  • confirmedTranscriptTimeoutMsinteger (int32)
  • proactiveLookupEnabledboolean
  • promptsarray of ToolPrompt
  • toolResultCacheConfigToolResultCacheConfig
  • toolConcurrencyConfigConcurrencyControlConfig
  • concurrencyLimitFallbackMessagestring
  • mockConfigobject
  • apiHeadersobject
  • apiBodyobject
  • sourceBuiltinToolKeystring
  • applicationTypestring
  • applicationIdstring (uuid)
  • requiresFollowUpboolean
  • hideFromChatTimelineboolean
  • discloseOutputSchemaboolean
  • requiresSandboxboolean
  • anonymizeInChatTimelineboolean
  • haltOnStepErrorboolean
  • tagsarray of string
  • catalogInclusionModesarray of string
  • isSystemboolean
  • userIdstring (uuid)
  • versioninteger (int32)
  • createdAtstring (date-time)
  • updatedAtstring (date-time)
  • createdByAiboolean
  • networkAllowListarray of string
  • creatorAgentIdstring (uuid)
  • creatorFlowIdstring (uuid)

Responses

  • 201Tool created successfully
  • 401Missing or invalid API key
  • 403Key is valid but lacks access to this resource
  • 404Requested resource not found

Get custom tool

GET/api/external/v1/tools/{toolId}

Retrieves the details of a specific tool definition by its unique UUID.

Parameters

  • toolIdstring (uuid)pathRequired

Responses

  • 200Tool details
  • 401Missing or invalid API key
  • 403Key is valid but lacks access to this resource
  • 404Requested resource not found

Update custom tool

PUT/api/external/v1/tools/{toolId}

Updates an existing custom tool definition by merging the incoming fields. System tools cannot be updated.

Parameters

  • X-Kilevel-Ai-Originstringheader
  • toolIdstring (uuid)pathRequired

Request body application/json

  • idstring (uuid)
  • namestring
  • descriptionstring
  • groupNamestring
  • iconKeystring
  • iconColorstring
  • parametersarray of ToolParameter
  • returnValueToolReturnValue
  • toolTypestring
  • toolSubtypestring
  • isAsyncboolean
  • internalOnlyboolean
  • asyncReturnTypestring
  • messagesToolMessages
  • executionPlanarray of object
  • integrationsarray of object
  • integrationCredentialLinksarray of object
  • forwardCallConfigForwardCallConfig
  • aimetaHintToolMetaHint
  • apiMethodstring
  • apiUrlstring
  • apiTimeoutSecondsinteger (int32)
  • toolCallTimeoutSecondsinteger (int32)
  • requiresConfirmedTranscriptboolean
  • confirmedTranscriptTimeoutMsinteger (int32)
  • proactiveLookupEnabledboolean
  • promptsarray of ToolPrompt
  • toolResultCacheConfigToolResultCacheConfig
  • toolConcurrencyConfigConcurrencyControlConfig
  • concurrencyLimitFallbackMessagestring
  • mockConfigobject
  • apiHeadersobject
  • apiBodyobject
  • sourceBuiltinToolKeystring
  • applicationTypestring
  • applicationIdstring (uuid)
  • requiresFollowUpboolean
  • hideFromChatTimelineboolean
  • discloseOutputSchemaboolean
  • requiresSandboxboolean
  • anonymizeInChatTimelineboolean
  • haltOnStepErrorboolean
  • tagsarray of string
  • catalogInclusionModesarray of string
  • isSystemboolean
  • userIdstring (uuid)
  • versioninteger (int32)
  • createdAtstring (date-time)
  • updatedAtstring (date-time)
  • createdByAiboolean
  • networkAllowListarray of string
  • creatorAgentIdstring (uuid)
  • creatorFlowIdstring (uuid)

Responses

  • 200Tool updated successfully
  • 401Missing or invalid API key
  • 403Key is valid but lacks access to this resource
  • 404Requested resource not found

Delete custom tool

DELETE/api/external/v1/tools/{toolId}

Permanently deletes a custom tool definition. This action cannot be undone.

Parameters

  • toolIdstring (uuid)pathRequired

Responses

  • 204Tool deleted successfully
  • 401Missing or invalid API key
  • 403Key is valid but lacks access to this resource
  • 404Requested resource not found